// CBrowseDlg.cpp : implementation file
//

#include "stdafx.h"

#include "cbrowse.h"
#include "CBrowseDlg.h"
#include "CBrowseEventSink.h"
#include "DHTMLCmdIds.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <math.h>
#include <fpieee.h>
#include <float.h>

#include <stack>

static const CLSID CLSID_Mozilla =
{ 0x1339B54C, 0x3453, 0x11D2, { 0x93, 0xB9, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00 } };

/////////////////////////////////////////////////////////////////////////////
// CBrowseDlg dialog

CBrowseDlg::CBrowseDlg(CWnd* pParent /*=NULL*/)
    : CDialog(CBrowseDlg::IDD, pParent)
{
    //{{AFX_DATA_INIT(CBrowseDlg)
    //}}AFX_DATA_INIT
    // Note that LoadIcon does not require a subsequent DestroyIcon in Win32
    m_pControlSite = NULL;
    m_szHomePage=_T("http://www.mozilla.org");
}

void CBrowseDlg::DoDataExchange(CDataExchange* pDX)
{
    CDialog::DoDataExchange(pDX);
    //{{AFX_DATA_MAP(CBrowseDlg)
    //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CBrowseDlg, CDialog)
    //{{AFX_MSG_MAP(CBrowseDlg)
    ON_WM_PAINT()
    ON_WM_QUERYDRAGICON()
    ON_WM_DESTROY()
    ON_WM_SIZE()
    ON_BN_CLICKED(IDC_BACKWARD, OnBackward)
    ON_BN_CLICKED(IDC_HOME, OnHome)
	ON_BN_CLICKED(IDC_PRINT, OnPrint)
	ON_BN_CLICKED(IDC_HELPB, OnHelpb)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

#define IL_CLOSEDFOLDER 0
#define IL_OPENFOLDER   1
#define IL_TEST         2
#define IL_TESTFAILED   3
#define IL_TESTPASSED   4
#define IL_TESTPARTIAL  5
#define IL_NODE         IL_TEST

/////////////////////////////////////////////////////////////////////////////
// CBrowseDlg message handlers

BOOL CBrowseDlg::OnInitDialog()
{
    CDialog::OnInitDialog();

    CWinApp *pApp = AfxGetApp();

    m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
    // Set the icon for this dialog.  The framework does this automatically
    //  when the application's main window is not a dialog
    SetIcon(m_hIcon, TRUE);         // Set big icon
    SetIcon(m_hIcon, FALSE);        // Set small icon

    // Get the position of the browser marker
    CRect rcAll,rcMarker;
	GetWindowRect(rcAll);
    GetDlgItem(IDC_BROWSER_MARKER)->GetWindowRect(&rcMarker);
    GetDlgItem(IDC_BROWSER_MARKER)->ShowWindow(FALSE);
	
	margin_left=rcMarker.left-rcAll.left;
	margin_top=rcMarker.top-rcAll.top;
	margin_right=rcAll.right-rcMarker.right;
	margin_bottom=rcAll.bottom-rcMarker.bottom;

    // Create the contained web browser
    CreateWebBrowser();

    Navigate(m_szHomePage);

    return TRUE;  // return TRUE  unless you set the focus to a control
}

bool CBrowseDlg::GetBrowserRect(RECT* r) const
{
	CRect rcAll;
	GetWindowRect(rcAll);
	ScreenToClient(rcAll);

	if(rcAll.Width() < margin_left+margin_right+10 ||
		rcAll.Height() < margin_top+margin_bottom+10) return false;

	r->left = rcAll.left+margin_left;
	r->top = rcAll.top+margin_top;
	r->right = rcAll.right-margin_right;
	r->bottom = rcAll.bottom-margin_bottom;

	return true;
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CBrowseDlg::OnPaint() 
{
    if (IsIconic())
    {
        CPaintDC dc(this); // device context for painting

        SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

        // Center icon in client rectangle
        int cxIcon = GetSystemMetrics(SM_CXICON);
        int cyIcon = GetSystemMetrics(SM_CYICON);
        CRect rect;
        GetClientRect(&rect);
        int x = (rect.Width() - cxIcon + 1) / 2;
        int y = (rect.Height() - cyIcon + 1) / 2;

        // Draw the icon
        dc.DrawIcon(x, y, m_hIcon);
    }
    else
    {
        CPaintDC dc(this);

        m_pControlSite->Draw(dc.m_hDC);
    }
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CBrowseDlg::OnQueryDragIcon()
{
    return (HCURSOR) m_hIcon;
}


BOOL CALLBACK CBrowseDlg::EnumChildProc(HWND hwnd, LPARAM lParam)
{
    CBrowseDlg *pThis = (CBrowseDlg*) lParam;

    switch (::GetDlgCtrlID(hwnd))
    {
    case IDC_BROWSER_MARKER:
        {
            CWnd *pMarker = pThis->GetDlgItem(IDC_BROWSER_MARKER);

			CRect r;

            if (pThis->GetBrowserRect(r))
            {
                pMarker->SetWindowPos(&CWnd::wndBottom, r.left, r.top, r.Width(), r.Height(), 
                        SWP_NOACTIVATE | SWP_HIDEWINDOW);
                pThis->m_pControlSite->SetPosition(r);
            }
        }
        break;
    }

    return TRUE;
}

void CBrowseDlg::OnSize(UINT nType, int cx, int cy) 
{
    CDialog::OnSize(nType, cx, cy);

    if (m_hWnd == NULL) return;

    ::EnumChildWindows(GetSafeHwnd(), CBrowseDlg::EnumChildProc, (LPARAM) this);
}

HRESULT CBrowseDlg::CreateWebBrowser()
{
	CRect r;
	GetBrowserRect(r);

    CBrowserCtlSiteInstance::CreateInstance(&m_pControlSite);
    if (m_pControlSite == NULL)
    {
        OutputError(_T("Could not create control site"));
        return E_OUTOFMEMORY;
    }

    CBrowseEventSinkInstance *pEventSink = NULL;
    CBrowseEventSinkInstance::CreateInstance(&pEventSink);
    if (pEventSink == NULL)
    {
        m_pControlSite->Release();
        m_pControlSite = NULL;
        OutputError(_T("Could not create event sink"));
        return E_OUTOFMEMORY;
    }
    pEventSink->m_pBrowseDlg = this;

    HRESULT hr;

    PropertyList pl;
    m_pControlSite->AddRef();
    m_pControlSite->m_bUseCustomPopupMenu = FALSE;
    m_pControlSite->m_bUseCustomDropTarget = FALSE;
    m_pControlSite->Create(CLSID_Mozilla, pl);
    hr = m_pControlSite->Attach(GetSafeHwnd(), r, NULL);
    if (hr != S_OK)
    {
        OutputError(_T("Cannot attach to browser control, hr = 0x%08x"), hr);
    }
    
    m_pControlSite->SetPosition(r);
    hr = m_pControlSite->Advise(pEventSink, DIID_DWebBrowserEvents2, &m_dwCookie);
    if (hr != S_OK)
    {
        OutputError(_T("Cannot subscribe to DIID_DWebBrowserEvents2 events, hr = 0x%08x"), hr);
    }

    CComPtr<IUnknown> spUnkBrowser;
    m_pControlSite->GetControlUnknown(&spUnkBrowser);

    CIPtr(IWebBrowser2) spWebBrowser = spUnkBrowser;
    if (spWebBrowser)
    {
        spWebBrowser->put_RegisterAsDropTarget(VARIANT_TRUE);
    }
    if (m_pControlSite)
    {
        IUnknown *pIUnkBrowser = NULL;
        m_pControlSite->GetControlUnknown(&pIUnkBrowser);
        if (pIUnkBrowser)
        {
            pIUnkBrowser->QueryInterface(IID_IWebBrowser, (void **) &m_webBrowser);
            pIUnkBrowser->Release();
            if (!m_webBrowser)
            {
                OutputError(_T("Cannot query interface IWebBrowser"));
                return E_FAIL;
            }
        }
    }

    return S_OK;
}


HRESULT CBrowseDlg::DestroyWebBrowser()
{
    if (m_pControlSite)
    {
        m_pControlSite->Unadvise(DIID_DWebBrowserEvents2, m_dwCookie);
        m_pControlSite->Detach();
        m_pControlSite->Release();
        m_pControlSite = NULL;
    }

    return S_OK;
}

CString CBrowseDlg::GetLocationURL()
{
	if(!m_webBrowser) return "";
    USES_CONVERSION;
    BSTR szLocation = NULL;
    m_webBrowser->get_LocationURL(&szLocation);
	CString result(szLocation);
    SysFreeString(szLocation);
	return result;
}

void CBrowseDlg::UpdateURL()
{
	GetLocationURL();
}


void CBrowseDlg::Navigate(LPCTSTR szURL)
{
    CComVariant vFlags(0);
    BSTR bstrURL = CString(szURL).AllocSysString();
    HRESULT hr = m_webBrowser->Navigate(bstrURL, &vFlags, NULL, NULL, NULL);
    if (FAILED(hr)) {
        OutputError("Navigate failed (hr=0x%08x)", hr);
    }
    ::SysFreeString(bstrURL);
}

struct _ElementPos
{
    HTREEITEM m_htiParent;
    CIPtr(IHTMLElementCollection) m_cpElementCollection;
    int m_nIndex;

    _ElementPos(HTREEITEM htiParent, IHTMLElementCollection *pElementCollection, int nIndex)
    {
        m_htiParent = htiParent;
        m_cpElementCollection = pElementCollection;
        m_nIndex = nIndex;
    }
    _ElementPos()
    {
    }
};

void CBrowseDlg::OnDestroy() 
{
    DestroyWebBrowser();
    CDialog::OnDestroy();
//    delete this;
	PostQuitMessage(0);
}

void CBrowseDlg::ExecOleCommand(const GUID *pguidGroup, DWORD nCmdId)
{
    CComPtr<IUnknown> spUnkBrowser;
    m_pControlSite->GetControlUnknown(&spUnkBrowser);

    CIPtr(IOleCommandTarget) spCommandTarget = spUnkBrowser;
    if (spCommandTarget)
    {
        HRESULT hr = spCommandTarget->Exec(&CGID_MSHTML, nCmdId, 0, NULL, NULL);
    }
    else
    {
        OutputError(_T("Browser does not support IOleCommandTarget"));
    }
}

void CBrowseDlg::OutputError(LPCTSTR str, ...)  
{
    va_list val;
    va_start(val,str);
    TCHAR s[1000];
    _vstprintf(s,str,val);
    AfxMessageBox(s,MB_OK|MB_ICONSTOP);
}

void CBrowseDlg::OnBackward() 
{
    m_webBrowser->GoBack(); 
}

void CBrowseDlg::OnHome() 
{
    Navigate(m_szHomePage); 
}

void CBrowseDlg::OnPrint() 
{
    ExecOleCommand(NULL, OLECMDID_PRINT);
}

void CBrowseDlg::OnOK() 
{
	if(AfxMessageBox(_T("    ?"),MB_YESNO|MB_ICONQUESTION|MB_DEFBUTTON2)==IDYES) {
		CDialog::OnOK();
	}
}

void CBrowseDlg::OnHelpb() 
{
	if(!m_szHelpUrl) return;
	CString s=GetLocationURL();

/* http://some.host/path/foo.html -> m_szHelpUrl#foo */
/* 012345678901234567890123456890, slash=21, dot=25 => Mid(22,3)*/
	int slash=s.ReverseFind('/');
	if(slash<0) return;
	int dot=s.ReverseFind('.');
	if(dot<0 || dot<slash) return;
	Navigate(m_szHelpUrl+'#'+s.Mid(slash+1,dot-slash-1));
}
