// ControlEventSink.cpp : Implementation of ControlEventSink
#include "stdafx.h"
#include "Cbrowse.h"
#include "ControlEventSink.h"

/////////////////////////////////////////////////////////////////////////////
// CControlEventSink

HRESULT STDMETHODCALLTYPE CControlEventSink::GetTypeInfoCount( 
    /* [out] */ UINT __RPC_FAR *pctinfo)
{
    return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE CControlEventSink::GetTypeInfo( 
    /* [in] */ UINT iTInfo,
    /* [in] */ LCID lcid,
    /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo)
{
    return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE CControlEventSink::GetIDsOfNames( 
    /* [in] */ REFIID riid,
    /* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
    /* [in] */ UINT cNames,
    /* [in] */ LCID lcid,
    /* [size_is][out] */ DISPID __RPC_FAR *rgDispId)
{
    return E_NOTIMPL;
}

HRESULT STDMETHODCALLTYPE CControlEventSink::Invoke( 
    /* [in] */ DISPID dispIdMember,
    /* [in] */ REFIID riid,
    /* [in] */ LCID lcid,
    /* [in] */ WORD wFlags,
    /* [out][in] */ DISPPARAMS __RPC_FAR *pDispParams,
    /* [out] */ VARIANT __RPC_FAR *pVarResult,
    /* [out] */ EXCEPINFO __RPC_FAR *pExcepInfo,
    /* [out] */ UINT __RPC_FAR *puArgErr)
{
    switch (dispIdMember)
    {
    case 0x66:
        {
            USES_CONVERSION;
            CString szText(OLE2T(pDispParams->rgvarg[0].bstrVal));
            OnStatusTextChange(szText);
        }
        break;
    case 0x6c:
        {
            LONG nProgress = pDispParams->rgvarg[1].lVal;
            LONG nProgressMax = pDispParams->rgvarg[0].lVal;
            OnProgressChange(nProgress, nProgressMax);
        }
        break;
    case 0x69:
        {
            BOOL enable = pDispParams->rgvarg[0].boolVal == VARIANT_TRUE ? TRUE : FALSE;
            LONG commandState = pDispParams->rgvarg[1].lVal;
            OnCommandStateChange(commandState, enable);
        }
        break;
    case 0x6a:
        OnDownloadBegin();
        break;
    case 0x68:
        OnDownloadComplete();
        break;
    case 0x71:
        {
            USES_CONVERSION;
            CString szText(OLE2T(pDispParams->rgvarg[0].bstrVal));
            OnTitleChange(szText);
        }
        break;
    case 0x70:
        {
            USES_CONVERSION;
            CString szText(OLE2T(pDispParams->rgvarg[0].bstrVal));
            OnPropertyChange(szText);
        }
        break;
    case 0xfa:
//        szEvent = _T("BeforeNavigate2");
        break;
    case 0xfb:
//        szEvent = _T("NewWindow2");
        break;
    case 0xfc:
//        szEvent = _T("NavigateComplete2");
        break;
    case 0x103:
//        szEvent = _T("DocumentComplete");
        break;
    case 0xfd:
//        szEvent = _T("OnQuit");
        break;
    case 0xfe:
//        szEvent = _T("OnVisible");
        break;
    case 0xff:
//        szEvent = _T("OnToolBar");
        break;
    case 0x100:
//        szEvent = _T("OnMenuBar");
        break;
    case 0x101:
//        szEvent = _T("OnStatusBar");
        break;
    case 0x102:
//        szEvent = _T("OnFullScreen");
        break;
    case 0x104:
//        szEvent = _T("OnTheaterMode");
        break;
    default:
        break;
    }
    return S_OK;
}
